#include <bits/stdc++.h>
using namespace std;
long long t, m, n, da[76000], ne[76000], raz, mn;

int main () {
cin >> t;


while (t--) {
    raz=9223372036854775807;
    cin >> n >> m;

    cin >> da[1];
    for (int i=2; i<=n; i++) {
        cin >> da[i];
        raz=min(raz, da[i]-da[i-1]);
    }


    for (int i=1; i<=m; i++) {
        cin >> ne[i];
}


   bool b;
    b=false;
   for (int i=2; i<=n; i++) {
    if ((da[i]-da[i-1])%raz!=0) {
        b=true;
    }
}
if (!b) {
    mn=da[1]%raz;
    for (int i=1; i<=m; i++) {
        if (ne[i]%raz==mn) {
            b=true;
        }
    }
}


if (!b){
    cout << 1 << endl;
}
else cout << 0 << endl;

}


return 0;
}